#!/usr/bin/env python3

import yaml
from collections import defaultdict
from pequod_agent.cluster.lbupdater.base import LBUpdater


class BootstrapLBUpdater(LBUpdater):

    def __init__(self, bootstrap_identifiers):
        self.external_services = defaultdict(list)
        self.pools = []
        # images don't have lb polls so we only need files
        # TODO: test if file exists instead of excluding every file with : in the name
        bootstrap_files = [i for i in bootstrap_identifiers if ':' not in i]
        for bootstrap_file in bootstrap_files:
            with open(bootstrap_file) as fd:
                data = yaml.safe_load(fd)
            if isinstance(data, dict):
                config = data.get('load_balancer', {})
                self.pools = config.get('pools', [])

    def get_all_pools(self):
        return self.pools
