#!/usr/bin/env python3
from pathlib import Path
from pequod_agent.constants.path import CGROUPS_SYSFS
from pequod_agent.utilities.decorators import coerce


class CGgroup:
    def __init__(self, name: str):
        self.name = name
        self.path = Path(name)

    @coerce
    def append(self, pid: str, sub_systems: list):
        line = '\n{pid}'.format(pid=pid)
        for sub_system in sub_systems:
            with self.subsystem_tasks(sub_system).open('a') as fd:
                fd.write(line)

    def subsystem_tasks(self, subsystem: str) -> Path:
        return CGROUPS_SYSFS / subsystem / self.path / 'tasks'
