import os
import shutil
from pequod_agent.errors import PreflightError


def check(msg: str, assertion: bool):
    """
    Helper function to raise a PreflightError if the assertion failed

    >>> check('ok', True)
    >>> check('error', False)
    Traceback (most recent call last):
      ...
    pequod_agent.errors.PreflightError: Preflight check failed: error
    """
    if not assertion:
        raise PreflightError(msg)


def preflight_checks():
    """
    Check that all requirements are met before doing anything real
    """
    check('The agent must be run as root', os.getuid() == 0)
    check('Bridge utils must be installed', shutil.which('brctl'))
    check('HAProxy must be installed', shutil.which('haproxy'))