from asyncio import get_event_loop, coroutine, Future, wait_for


def _set_result(future, function, *args, **kwargs):
    future.set_result(function(*args, **kwargs))


@coroutine
def run_async(function, *args, **kwargs):
    event_loop = get_event_loop()
    future = Future()
    event_loop.call_soon(_set_result, future, function, *args, **kwargs)
    yield from wait_for(future, None)
    return future.result()
